/* ===============================================================
   Differences in variable initialisation and use of atomic blocks
    [ Irene ~ lobo@student.chalmers.se ]
   =============================================================== */

#define N 5

byte b = 0;

init {
  byte n = 0;

  /* If the convention of creating all processes in an atomic block
     is followed... */
  atomic {
    do
      :: n >= N -> break
      :: else  -> run P();
                  n++
    od;
  }

  (_nr_pr == 1);

  printf("it is: %d\n",b);
  
  /* ... all processes are created simultaneously and hence, their
     corresponding _tmp_ variables are created and initialised to the
     initial value of _b_ (0) since the initialisation is made at
     declaration  =>  all processes right back the same value to _b_ */ 
  assert(b == 1);

  /* If the atomic block is removed or _tmp_ is not initialised at
     declaration, any of these other values could be obtained */
  // assert(b >= 1 && b <= N)
}

proctype P() {
  byte tmp = b;
  // tmp = b;
  tmp ++;
  b = tmp;
}

